<div width='100%'>
    <ul class='thumbnails' style='width:1200px;margin:0px auto;'>
        <li class='span3'>
            <div class='thumbnail'>
                <div id='pie' class='chartrender'>
                </div>
                <h5><a class='btn btn-small fullscreen-button' data='#pie'><i class='icon-resize-full'></i></a><?php echo lang('pie_chart'); ?></h5>
            </div>
        </li>
        <?php foreach($datasets as $dataset => $description): ?>
        <li class='span3'>
            <div class='thumbnail'>
                <div id='<?php echo $dataset; ?>' class='chartrender'>
                    <div class='reportviz-throbber'>
                        <div class='valign-throbber centerme'>
                            <img src='/nagiosna/media/images/ajax-loader.gif'>
                        </div>
                    </div>
                </div>
                <h5><a class='btn btn-small fullscreen-button' data='#<?php echo $dataset; ?>'><i class='icon-resize-full'></i></a><?php echo $description; ?></h5>
            </div>
        </li>
        <?php endforeach ?>
    </ul>
</div>

<script>
var aggs = <?php echo json_encode(array_keys($datasets)); ?>;
var aggt = <?php echo json_encode(array_values($datasets)); ?>;
var g_title = '<?php echo $title; ?>';

if(g_title.match(/^[0-9a-f]+$/i) != null) {
    g_title = '<?php echo lang("custom_report"); ?>';
}

$(document).ready(function() {
    var theight = 150;
    var twidth  = 250;
    
    make_pie();
    
    $.each(aggs, function(i,d) {
        make_chord(d, 600, 900, aggt[i]);
    });
    
    $('.fullscreen-button').click(function() {
        resize_to_fullscreen(this);
    });
});

function resize_to_fullscreen(node) {
    
    var div_id = $(node).attr('data');
    var w = $(window).width();
    $(div_id).addClass('front-and-center');
    $(div_id).addClass('well');
    
    switch(div_id) {
        case '#pie':
            pie.setSize(900, 700);
            pie.setTitle({ text: g_title});
            break;
        <?php foreach($datasets as $dataset => $garbage): ?>
        case '#<?php echo $dataset; ?>':
            
            break;
        <?php endforeach ?>
        default:
            break;
    }

    $(div_id).animate({
        top: 20,
        left: ((w - 900) / 2)
    });
    
    var title = $(node).parent().text();
    
    $(div_id).prepend('<span id="graph-title"><a id="make-normal-size" onclick="resize_to_normal(\'' + div_id + '\')" class="btn"><i class="icon-resize-small"></i></a>&nbsp;' + title + '</span>');
}

function resize_to_normal(div_id) {
    $(div_id).animate({ top:0, 
                        left:0
    })
    .removeClass('front-and-center')
    .removeClass('well')
    .children('span#graph-title').each(function(i,d) { $(d).remove(); });
    
    switch(div_id) {
        case '#pie':
            pie.setSize(250, 150);
            pie.setTitle({text: ' '});
            break;
        <?php foreach($datasets as $dataset => $garbage): ?>
        case '#<?php echo $dataset; ?>':
            
            break;
        <?php endforeach ?>
        default:
            break;
    }
}

function make_pie()
{
    var json = <?php echo $json; ?>;
    
    $(function () {
        
        pie = new Highcharts.Chart({
            chart: {
                renderTo: 'pie',
                backgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false,
            },
            credits: {
                enabled: false
            },
            title: {
                text: ' '
            },
            tooltip: {
                pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000',
                        format: '<b>{point.name}</b>: {point.percentage:.1f} %'
                    }
                }
            },
            series: json
        });
        pie.setTitle(' ');
    });
    
    if(json[0].data[0].name == null) {
        $('#highcharts-0').html('<div class="text-center"><?php echo lang("no_data"); ?></div>');
    }
}

function make_chord(agg2, h, w, title)
{

    var r1 = h / 2,
        r0 = r1 - 80;
    
    
    var fill = d3.scale.category20c();
    
    var chord = d3.layout.chord()
        .padding(.04)
        .sortSubgroups(d3.descending)
        .sortChords(d3.descending);

    var arc = d3.svg.arc()
        .innerRadius(r0)
        .outerRadius(r0 + 20);
    
    var svg = d3.select("#" + agg2).append("svg:svg")
        .attr("viewBox", "0 0 " + w + " " + h)
        .attr("width", "100%")
        .attr("height", "100%")
      .append("svg:g")
        .attr("transform", "translate(" + w / 2 + "," + h / 2 + ")");
    window[agg2] = svg;
    
    d3.json('<?php echo "{$apiurl}?{$chordquery}"; ?>' + "&agg2=" + agg2, function(imports) {
        
      var indexByName = {},
          nameByIndex = {},
          matrix = imports.matrix,
          labels = imports.names,
          diff = imports.diff,
          warning = imports.warning,
          n = 0;

      self.names = [];

      // Compute a unique index for each package name.
      labels.forEach(function(d) {
        if (!(d in indexByName)) {
          nameByIndex[n] = d;
          indexByName[d] = n++;
          names.push(d);
        }
      });

      chord.matrix(matrix);

      var g = svg.selectAll("g.group")
          .data(chord.groups)
        .enter().append("svg:g")
          .attr("class", "group")
          .on("mouseover", fade(.02))
          .on("mouseout", fade(.80));

      g.append("svg:path")
          .style("stroke", function(d) { return fill(d.index); })
          .style("fill", function(d) { return fill(d.index); })
          .attr("d", arc);

      g.append("svg:text")
          .each(function(d) { d.angle = (d.startAngle + d.endAngle) / 2; })
          .attr("dy", ".35em")
          .attr("text-anchor", function(d) { return d.angle > Math.PI ? "end" : null; })
          .attr("transform", function(d) {
            return "rotate(" + (d.angle * 180 / Math.PI - 90) + ")"
                + "translate(" + (r0 + 26) + ")"
                + (d.angle > Math.PI ? "rotate(180)" : "");
          })
          .attr("class", function(d) {
                return (diff[d.index]) ? 'black' : 'gray';})
          .text(function(d) { return nameByIndex[d.index]; });

      svg.selectAll("path.chord")
          .data(chord.chords)
        .enter().append("svg:path")
          .attr("class", "chord")
          .style("stroke", function(d) { return d3.rgb(fill(d.source.index)).darker(); })
          .style("fill", function(d) { return fill(d.source.index); })
          .attr("d", d3.svg.chord().radius(r0));

          $('#' + agg2).children('.reportviz-throbber').hide();
        
        svg.append('svg:title').text(title);
        
        if(warning) {
            svg.append('text')
                .attr('x', width/2)
                .attr('y', 0 - (margin.top/2))
                .attr('text-anchor', 'middle')
                .style('font-size', '10px')
                .text('Dataset was truncated due to size.');
        }

    });

    // Returns an event handler for fading a given chord group.
    function fade(opacity) {
      return function(d, i) {
        svg.selectAll("path.chord")
            .filter(function(d) { return d.source.index != i && d.target.index != i; })
          .transition()
            .style("stroke-opacity", opacity)
            .style("fill-opacity", opacity);
      };
    }
}
</script>
